#!/bin/sh
#
# Component: tools
#
# Description:
#    Prints queue status information.
#
# Usage:
#      qst.sh [-L] {cpu|net} [scheduled|retry|failed]
#
# Last Updated     : $Author$
# Update Date Time : $Date$
# RCS File Name    : $RCSfile$
# RCS Revision     : $Revision$
# Locked by        : $Locker$
# Symbolic name    : $Name$
# State            : $State$
#

LISTQUEUES=""

#List legacy queues
[ "$1" = "-L" ] && LISTQUEUES="cpu net"

[ -z "$1" ] && LISTQUEUES="task"

if [ -n "$LISTQUEUES" ] ; then
	for q in $LISTQUEUES ; do
		echo "Unprocessed :"$'\t'`find $HOME/var/${q}queue/ -maxdepth 1 -type f | wc -l`
		for qq in $(find $HOME/var/${q}queue/ -mindepth 1 -maxdepth 1 -type d |awk -F / '{print $6}') ; do
			echo $'\t'"${qq%.} :"$'\t'`find $HOME/var/${q}queue/${qq} -mindepth 1 -maxdepth 1 -type f | wc -l`
		done
	done

#	echo For more details use `basename $0` '[-L] {task|cpu|net} [scheduled|retry|failed]'
	exit 0
fi

if [ "$1" = "-h" ] ; then
  echo Usage: `basename $0` '[-L] {task|cpu|net} [scheduled|retry|failed]'
  exit 1;
fi

ST=$2
[ -z "$ST" ] && ST=scheduled

echo
echo Detailed status of the $1 $ST queue per priority:
echo
echo "prty  #tasks"
echo "------------"

DIR=$HOME/var/$1queue/.$ST

find $DIR -mindepth 1 -maxdepth 1 -type f | awk -F / '{print $7}' | awk -F . -v dir=$DIR '
 { d[$1]++; n++; s[$1]=$0; }
END { for (i in d){
      f = dir "/" s[i];
      getline cmd0 < f;
      split(cmd0,cmd1," ");
      nf=split(cmd1[1],cmd2,"/");
      ss=cmd2[nf];
  

      printf "%4s  % 6d   ( ?? %s ??)\n",i, d[i],ss | "sort";
      }
      close("sort")
      printf "============\n";
      printf "Total:% 6d\n", n }
 '
